VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7185
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11340
   LinkTopic       =   "Form1"
   ScaleHeight     =   7185
   ScaleWidth      =   11340
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox edtNumBars 
      Height          =   375
      Left            =   8040
      TabIndex        =   21
      Top             =   1920
      Width           =   855
   End
   Begin VB.OptionButton optHistoryDays 
      Caption         =   "Days"
      Height          =   255
      Left            =   5520
      TabIndex        =   19
      Top             =   1920
      Width           =   1095
   End
   Begin VB.OptionButton optHistoryBars 
      Caption         =   "Bars"
      Height          =   255
      Left            =   5520
      TabIndex        =   18
      Top             =   1560
      Width           =   975
   End
   Begin VB.TextBox edtHistoryInterval 
      Height          =   375
      Left            =   4440
      TabIndex        =   17
      Top             =   1920
      Width           =   855
   End
   Begin VB.CommandButton cmdRequestHistory 
      Caption         =   "Request History"
      Height          =   375
      Left            =   9480
      TabIndex        =   22
      Top             =   1920
      Width           =   1455
   End
   Begin VB.TextBox edtHistorySymbol 
      Height          =   375
      Left            =   1800
      TabIndex        =   15
      Top             =   1920
      Width           =   975
   End
   Begin VB.ListBox lstHistory 
      Height          =   4545
      Left            =   120
      TabIndex        =   23
      Top             =   2400
      Width           =   10935
   End
   Begin VB.TextBox edtLast 
      Height          =   375
      Left            =   8640
      TabIndex        =   13
      Top             =   960
      Width           =   1095
   End
   Begin VB.TextBox edtAsk 
      Height          =   375
      Left            =   7440
      TabIndex        =   11
      Top             =   960
      Width           =   1095
   End
   Begin VB.TextBox edtBid 
      Height          =   375
      Left            =   6120
      TabIndex        =   9
      Top             =   960
      Width           =   1095
   End
   Begin VB.TextBox edtRequestSymbol 
      Height          =   375
      Left            =   6120
      TabIndex        =   6
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton cmdRequest 
      Caption         =   "Request Quote"
      Height          =   375
      Left            =   7920
      TabIndex        =   7
      Top             =   120
      Width           =   1455
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update"
      Height          =   375
      Left            =   2520
      TabIndex        =   4
      Top             =   1080
      Width           =   1455
   End
   Begin VB.TextBox edtNewSymbol 
      Height          =   375
      Left            =   2520
      TabIndex        =   3
      Top             =   600
      Width           =   1695
   End
   Begin VB.TextBox edtCurrentSymbol 
      Height          =   375
      Left            =   2520
      TabIndex        =   1
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label Label9 
      Alignment       =   1  'Right Justify
      Caption         =   "# to load"
      Height          =   255
      Left            =   6840
      TabIndex        =   20
      Top             =   2040
      Width           =   975
   End
   Begin VB.Label Label8 
      Alignment       =   1  'Right Justify
      Caption         =   "History Interval"
      Height          =   255
      Left            =   3000
      TabIndex        =   16
      Top             =   1920
      Width           =   1215
   End
   Begin VB.Label Label7 
      Alignment       =   1  'Right Justify
      Caption         =   "History Symbol"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   1920
      Width           =   1335
   End
   Begin VB.Label Label6 
      Caption         =   "Last"
      Height          =   255
      Left            =   8640
      TabIndex        =   12
      Top             =   600
      Width           =   975
   End
   Begin VB.Label Label5 
      Caption         =   "Ask"
      Height          =   255
      Left            =   7440
      TabIndex        =   10
      Top             =   600
      Width           =   975
   End
   Begin VB.Label Label4 
      Caption         =   "Bid"
      Height          =   255
      Left            =   6120
      TabIndex        =   8
      Top             =   600
      Width           =   975
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Quote Symbol"
      Height          =   255
      Left            =   4560
      TabIndex        =   5
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Change Symbol in eSignal"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   2175
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Current Symbol in eSignal:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim sLastSymbol As String
Dim lHistoryHandle As Long
Dim lLastHistoryCount As Long

Private Sub ReleaseHistory()
    If lHistoryHandle <> 0 Then
        esignal.ReleaseHistory lHistoryHandle
        lHistoryHandle = 0
        lLastHistoryCount = 0
    End If
End Sub
Private Sub RequestSymbol(sSymbol As String)
    ReleaseSymbol
    sLastSymbol = sSymbol
    esignal.RequestSymbol sSymbol, True
    
End Sub

Private Sub ReleaseSymbol()
    If sLastSymbol <> "" Then
        esignal.ReleaseSymbol sLastSymbol
        sLastSymbol = ""
    End If
End Sub

Private Sub cmdRequest_Click()
    If cmdRequest.Caption = "Request Quote" Then
        Dim sSymbol As String
        sSymbol = edtRequestSymbol.Text
        Trim (sSymbol)
        If sSymbol <> "" Then
            RequestSymbol sSymbol
            cmdRequest.Caption = "Stop Quote"
        End If
    ElseIf cmdRequest.Caption = "Stop Quote" Then
        ReleaseSymbol
        cmdRequest.Caption = "Request Quote"
    End If
    
End Sub

Private Sub cmdRequestHistory_Click()
    Dim sSymbol As String
    Dim sInterval As String
    
    sSymbol = edtHistorySymbol.Text
    sInterval = edtHistoryInterval.Text
    
    sSymbol = Trim(sSymbol)
    sInterval = Trim(sInterval)
    
    If sSymbol = "" Then
        MsgBox "You must provide a symbol"
        Exit Sub
    End If
    
    If sInterval = "" Then
        MsgBox "You must provide an interval"
        Exit Sub
    End If
    
    ' Start/End Time
    ' if either is -1, that means auto time and eSignal will use the trading times from the exchange
    ' If there are 0 and 0, that is 24 hours.
    ' Otherwise, you can specify your own start/end time.
    ' Computed as:  HHMM where  (H*60)+M
    
    ReleaseHistory
    lstHistory.Clear
    
    Dim bt As IESignal.barType
    Dim nNumBars As Long
    
    If optHistoryBars.Value = True Then
        bt = btBARS
    Else
        bt = btDAYS
    End If
    
    nNumBars = Val(edtNumBars.Text)
    If nNumBars = 0 Then
        If bt = btBARS Then
            nNumBars = 600
        Else
            nNumBars = 30
        End If
    End If
        
    lHistoryHandle = esignal.RequestHistory(sSymbol, sInterval, bt, nNumBars, -1, -1)
    
    If esignal.IsHistoryReady(lHistoryHandle) = True Then
        FillHistory
    End If
    
    
End Sub

Private Sub esignal_OnBarsChanged(ByVal lHandle As Long)
    FillHistory
End Sub

Private Sub esignal_OnBarsReceived(ByVal lHandle As Long)
    FillHistory
End Sub

Private Function FormatBarData(lIndex As Long, item As BarData)
    Dim sRet As String
    
    ' currently only deals with intervals of 1 and higher. (or p,v,t,s tick charts)
    ' this is capapble of doing raw ticks, just not formatting the data out.
    sRet = Str$(item.dtTime)
    sRet = sRet + ": " + Str$(item.dOpen)
    sRet = sRet + ", " + Str$(item.dHigh)
    sRet = sRet + ", " + Str$(item.dLow)
    sRet = sRet + ", " + Str$(item.dClose)
    
    FormatBarData = sRet
End Function

Private Sub FillHistory()
    ' this function handles all bars received and bar updates
    Dim lNumBars As Long
    Dim baritem As IESignal.BarData
    Dim lBar As Long
    Dim sBar As String
    
    lNumBars = esignal.GetNumBars(lHistoryHandle)
    If lNumBars = 0 Then
        Exit Sub
    End If
    
    If lstHistory.ListCount > 0 And lNumBars = lLastHistoryCount Then
        ' update the top bar
        baritem = esignal.GetBar(lHistoryHandle, 0)
        sBar = FormatBarData(0, baritem)
        
        lstHistory.List(0) = sBar
    ElseIf lstHistory.ListCount > 0 And lNumBars = lLastHistoryCount + 1 Then
        ' add a new bar
        baritem = esignal.GetBar(lHistoryHandle, 0)
        sBar = FormatBarData(0, baritem)
        lstHistory.AddItem sBar, 0
    ElseIf lstHistory.ListCount = 0 Or lNumBars <> lLastHistoryCount + 1 Then
        ' refresh entire list box.
        For lBar = -(lNumBars - 1) To 0
            baritem = esignal.GetBar(lHistoryHandle, lBar)
            sBar = FormatBarData(lBar, baritem)
            lstHistory.AddItem sBar, 0
        Next lBar
        
    End If
    
    lLastHistoryCount = lNumBars
    
End Sub
Private Sub cmdUpdate_Click()
    Dim sNewSymbol As String
    sNewSymbol = edtNewSymbol.Text
    Trim (sNewSymbol)
    
    If sNewSymbol <> "" Then
        esignal.DoSymbolLink sNewSymbol
    End If
    
    
End Sub

Private Sub esignal_OnQuoteChanged(ByVal sSymbol As String)
    Dim quote As IESignal.BasicQuote
    
    quote = esignal.GetBasicQuote(sSymbol)
    
    edtBid.Text = Str$(quote.dBid)
    edtAsk.Text = Str$(quote.dAsk)
    edtLast.Text = Str$(quote.dLast)
End Sub

Private Sub esignal_OnSymbolChanged(ByVal sSymbol As String)
    edtCurrentSymbol.Text = sSymbol
End Sub


Private Sub Form_Load()
    Set esignal = New IESignal.Hooks
    lHistoryHandle = 0
    lLastHistoryCount = 0
    
    esignal.SetApplication ("****** PUT YOUR LOGIN NAME HERE CASE SENSITIVE *****")
    
    optHistoryBars.Value = True
    
    edtCurrentSymbol.Text = esignal.GetCurrentLinkingSymbol
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ReleaseSymbol
    ReleaseHistory
    Set esignal = Nothing
End Sub

